use std::collections::HashMap;

use serde::{Deserialize, Serialize};

use deckster_shared::path::{KeyPath, KnobPath};

use crate::handler_runner::KeyOrKnobHandlerConfig;

#[derive(Debug, Serialize, Deserialize)]
pub struct HandlerHostsConfig {
    pub run_id: Box<str>,
    pub keys: HashMap<KeyPath, KeyOrKnobHandlerConfig>,
    pub knobs: HashMap<KnobPath, KeyOrKnobHandlerConfig>,
}

#[derive(Debug, Deserialize)]
pub struct MqttConfig {
    pub client_id: String,
    pub host: String,
    pub port: u16,
    pub credentials: Option<MqttConfigCredentials>,
    pub topic_prefix: String,
}

#[derive(Debug, Deserialize)]
pub struct MqttConfigCredentials {
    pub username: String,
    pub password: String,
}
